;************************************************************************
;*									*
;*	Icon Patch Kludge			title:			*
;*	Installation Module			installIP.asm		*
;*									*
;************************************************************************

Install:
	bra	Install1
	
ipMemFull: dc.w 0		; Flag indicating if icons have filled
				; the buffer yet.

LABEL 'Install'
Install1:
	movem.l	a0-a5/d1-d6,-(sp)

; Allocate local storage pointer.
	move.l	#mySize,d0
	_NewPtr,SYS+CLEAR
	tst	d0
	bne	installBad
	move.l	a0,d0
	tst.l	d0
	beq	installBad
	lea	a4Save(pc),a1
	move.l	a0,(a1)

; Set up a4.
	move.l	a0,a4

; Allocate scratch cicn space
	move.l	#MAX_CICN,d0
	_NewHandle,SYS+CLEAR
	tst	d0
	bne	installBad
	move.l	a0,d0
	tst.l	d0
	beq	installBad	
	lea	scratchCicn(a4),a1	; save the handle
	move.l	a0,(a1)

; Allocate scratch ctab space
	move.l	#MAX_CTAB,d0
	_NewHandle,SYS+CLEAR
	tst	d0
	bne	installBad
	move.l	a0,d0
	tst.l	d0
	beq	installBad	
	lea	scratchCtab(a4),a1	; save the handle
	move.l	a0,(a1)

; Allocate scratch cicn image space
	move.l	#MAX_IMAGE,d0
	_NewHandle,SYS+CLEAR
	tst	d0
	bne	installBad
	move.l	a0,d0
	tst.l	d0
	beq	installBad	
	lea	scratchImage(a4),a1	; save the handle
	move.l	a0,(a1)

; Allocate space to store icons.  First get 'sysz' resource to find out
; how much we should allocate.
;
	clr.l	-(sp)		; space for return value
	move.l	#'sysz',-(sp)	; type 'sysz'
	clr	-(sp)		; id = 0
	_GetResource
	move.l	(sp)+,a0	; gets handle
	move.l	a0,d0		; test for NIL handle
	tst.l	d0
	beq	installBad
	move.l	(a0),a0		; gets pointer
	move.l	a0,d0		; test for NIL master pointer
	tst.l	d0
	beq	installBad
	
	move.l	(a0),d0		; gets size
	sub.l	#CODESIZE+mySize+MAX_CICN+MAX_CTAB+MAX_IMAGE,d0
	ble	installBad	; test for less than zero left
	move.l	d0,d7		; save for later

	_NewPtr,SYS+CLEAR	; allocate it
	tst	d0
	bne	installBad
	move.l	a0,d0
	tst.l	d0
	beq	installBad

; Initialize linked-list of icons.
	lea	HeadPointer(a4),a1	; Set head pointer.
	move.l	a0,(a1)

	clr.l	(a0)			; Set "next" pointer of first icon.

	lea	TailPointer(a4),a1	; Init tail pointer.
	move.l	a0,(a1)
	
	add.l	d7,a0			; init ptr to end of storage
	lea	EndOfStorage(a4),a1
	move.l	a0,(a1)

; Install patches
	bsr	PInstall

; Do a GetResource on all ICN#'s in the current resource file.  This makes the
; patch load in color icons from the INIT file, thereby letting people define
; color icon aliases without modifying other files.
	clr	-(sp)
	move.l	#'ICN#',-(sp)
	dc.w	$A80D	; _Count1Resources
	move	(sp)+,d7		; number of resources in d7

loadIconLoop:
	tst	d7		; any more icons?
	ble	installOK	; no - quit.

	clr.l	-(sp)
	move.l	#'ICN#',-(sp)
	move	d7,-(sp)
	dc.w	$A80E	; _Get1IxResource
	move.l	(sp)+,a0

	move.l	a0,d0		; test for errors
	tst.l	d0
	beq	liNext
	tst.l	(a0)
	beq	liNext
	
	move.l	a0,-(sp)	; resource handle
	pea	scratchID(a4)
	pea	scratchType(a4)
	pea	scratchName(a4)
	_GetResInfo		; find out ID
	
	clr.l	-(sp)		; now get the resource again, accessing it
				; by its ID.
	move.l	#'ICN#',-(sp)
	move	scratchID(a4),-(sp)
	_GetResource
	move.l	(sp)+,a0

	move.l	a0,-(sp)	; release the resource
	_ReleaseResource

liNext:	subq	#1,d7
	bra	loadIconLoop

installOK:
	moveq	#0,d0

installDone:
	tst.w	d0
	movem.l	(sp)+,a0-a5/d1-d6
	rts

installBad:
	moveq	#-1,d0
	bra	installDone


; end of install.asm

